# Source code for azure.mgmt.storage.v2018_07_01.operations._blob_containers_operations

    # coding=utf-8
    # --------------------------------------------------------------------------
    # Copyright (c) Microsoft Corporation. All rights reserved.
    # Licensed under the MIT License. See License.txt in the project root for
    # license information.
    #
    # Code generated by Microsoft (R) AutoRest Code Generator.
    # Changes may cause incorrect behavior and will be lost if the code is
    # regenerated.
    # --------------------------------------------------------------------------

    import uuid
    from msrest.pipeline import ClientRawResponse
    from msrestazure.azure_exceptions import CloudError

    from .. import models

    class BlobContainersOperations(object):
        """BlobContainersOperations operations.

        You should not instantiate directly this class, but create a Client instance that will create it for you and attach it as attribute.

        :param client: Client for service requests.
        :param config: Configuration of service client.
        :param serializer: An object model serializer.
        :param deserializer: An object model deserializer.
        :ivar api_version: The API version to use for this operation. Constant value: "2018-07-01".
        :ivar immutability_policy_name: The name of the blob container immutabilityPolicy within the specified storage account. ImmutabilityPolicy Name must be 'default'. Constant value: "default".
        """

        models = models

        def __init__(self, client, config, serializer, deserializer):

            self._client = client
            self._serialize = serializer
            self._deserialize = deserializer
            self.api_version = "2018-07-01"
            self.immutability_policy_name = "default"

            self.config = config

        def list(
                self, resource_group_name, account_name, custom_headers=None, raw=False, **operation_config):
            """Lists all containers and does not support a prefix like data plane.
            Also SRP today does not return continuation token.

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: ListContainerItems or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.ListContainerItems or
             ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.list.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.get(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('ListContainerItems', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        list.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers'}

        def create(
                self, resource_group_name, account_name, container_name, public_access=None, metadata=None, custom_headers=None, raw=False, **operation_config):
            """Creates a new container under the specified account as described by
            request body. The container resource includes metadata and properties
            for that container. It does not include a list of the blobs contained
            by the container. .

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param public_access: Specifies whether data in the container may be
             accessed publicly and the level of access. Possible values include:
             'Container', 'Blob', 'None'
            :type public_access: str or
             ~azure.mgmt.storage.v2018_07_01.models.PublicAccess
            :param metadata: A name-value pair to associate with the container as
             metadata.
            :type metadata: dict[str, str]
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: BlobContainer or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.BlobContainer or
             ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            blob_container = models.BlobContainer(public_access=public_access, metadata=metadata)

            # Construct URL
            url = self.create.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(blob_container, 'BlobContainer')

            # Construct and send request
            request = self._client.put(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [201]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None
            if response.status_code == 201:
                deserialized = self._deserialize('BlobContainer', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        create.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}'}

        def update(
                self, resource_group_name, account_name, container_name, public_access=None, metadata=None, custom_headers=None, raw=False, **operation_config):
            """Updates container properties as specified in request body. Properties
            not mentioned in the request will be unchanged. Update fails if the
            specified container doesn't already exist. .

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param public_access: Specifies whether data in the container may be
             accessed publicly and the level of access. Possible values include:
             'Container', 'Blob', 'None'
            :type public_access: str or
             ~azure.mgmt.storage.v2018_07_01.models.PublicAccess
            :param metadata: A name-value pair to associate with the container as
             metadata.
            :type metadata: dict[str, str]
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: BlobContainer or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.BlobContainer or
             ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            blob_container = models.BlobContainer(public_access=public_access, metadata=metadata)

            # Construct URL
            url = self.update.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(blob_container, 'BlobContainer')

            # Construct and send request
            request = self._client.patch(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('BlobContainer', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        update.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}'}

        def get(
                self, resource_group_name, account_name, container_name, custom_headers=None, raw=False, **operation_config):
            """Gets properties of a specified container. .

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: BlobContainer or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.BlobContainer or
             ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.get.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.get(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('BlobContainer', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        get.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}'}

        def delete(
                self, resource_group_name, account_name, container_name, custom_headers=None, raw=False, **operation_config):
            """Deletes specified container under its account.

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: None or ClientRawResponse if raw=true
            :rtype: None or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.delete.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.delete(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200, 204]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                return client_raw_response
        delete.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}'}

        def set_legal_hold(
                self, resource_group_name, account_name, container_name, tags, custom_headers=None, raw=False, **operation_config):
            """Sets legal hold tags. Setting the same tag results in an idempotent
            operation. SetLegalHold follows an append pattern and does not clear
            out the existing tags that are not specified in the request.

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param tags: Each tag should be 3 to 23 alphanumeric characters and is
             normalized to lower case at SRP.
            :type tags: list[str]
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: LegalHold or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.LegalHold or
             ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            legal_hold = models.LegalHold(tags=tags)

            # Construct URL
            url = self.set_legal_hold.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(legal_hold, 'LegalHold')

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('LegalHold', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        set_legal_hold.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}/setLegalHold'}

        def clear_legal_hold(
                self, resource_group_name, account_name, container_name, tags, custom_headers=None, raw=False, **operation_config):
            """Clears legal hold tags. Clearing the same or non-existent tag results
            in an idempotent operation. ClearLegalHold clears out only the
            specified tags in the request.

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param tags: Each tag should be 3 to 23 alphanumeric characters and is
             normalized to lower case at SRP.
            :type tags: list[str]
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: LegalHold or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.LegalHold or
             ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            legal_hold = models.LegalHold(tags=tags)

            # Construct URL
            url = self.clear_legal_hold.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(legal_hold, 'LegalHold')

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('LegalHold', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        clear_legal_hold.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}/clearLegalHold'}

        def create_or_update_immutability_policy(
                self, resource_group_name, account_name, container_name, immutability_period_since_creation_in_days, if_match=None, custom_headers=None, raw=False, **operation_config):
            """Creates or updates an unlocked immutability policy. ETag in If-Match is
            honored if given but not required for this operation.

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param immutability_period_since_creation_in_days: The immutability
             period for the blobs in the container since the policy creation, in
             days.
            :type immutability_period_since_creation_in_days: int
            :param if_match: The entity state (ETag) version of the immutability
             policy to update. A value of "*" can be used to apply the operation
             only if the immutability policy already exists. If omitted, this
             operation will always be applied.
            :type if_match: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: ImmutabilityPolicy or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.ImmutabilityPolicy or
             ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            parameters = None
            if immutability_period_since_creation_in_days is not None:
                parameters = models.ImmutabilityPolicy(immutability_period_since_creation_in_days=immutability_period_since_creation_in_days)

            # Construct URL
            url = self.create_or_update_immutability_policy.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'immutabilityPolicyName': self._serialize.url("self.immutability_policy_name", self.immutability_policy_name, 'str'),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if if_match is not None:
                header_parameters['If-Match'] = self._serialize.header("if_match", if_match, 'str')
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            if parameters is not None:
                body_content = self._serialize.body(parameters, 'ImmutabilityPolicy')
            else:
                body_content = None

            # Construct and send request
            request = self._client.put(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            header_dict = {}
            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('ImmutabilityPolicy', response)
                header_dict = {
                    'ETag': 'str',
                }

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                client_raw_response.add_headers(header_dict)
                return client_raw_response

            return deserialized
        create_or_update_immutability_policy.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}/immutabilityPolicies/{immutabilityPolicyName}'}

        def get_immutability_policy(
                self, resource_group_name, account_name, container_name, if_match=None, custom_headers=None, raw=False, **operation_config):
            """Gets the existing immutability policy along with the corresponding ETag
            in response headers and body.

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param if_match: The entity state (ETag) version of the immutability
             policy to update. A value of "*" can be used to apply the operation
             only if the immutability policy already exists. If omitted, this
             operation will always be applied.
            :type if_match: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: ImmutabilityPolicy or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.ImmutabilityPolicy or
             ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.get_immutability_policy.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'immutabilityPolicyName': self._serialize.url("self.immutability_policy_name", self.immutability_policy_name, 'str'),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if if_match is not None:
                header_parameters['If-Match'] = self._serialize.header("if_match", if_match, 'str')
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.get(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            header_dict = {}
            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('ImmutabilityPolicy', response)
                header_dict = {
                    'ETag': 'str',
                }

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                client_raw_response.add_headers(header_dict)
                return client_raw_response

            return deserialized
        get_immutability_policy.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}/immutabilityPolicies/{immutabilityPolicyName}'}

        def delete_immutability_policy(
                self, resource_group_name, account_name, container_name, if_match, custom_headers=None, raw=False, **operation_config):
            """Aborts an unlocked immutability policy. The response of delete has
            immutabilityPeriodSinceCreationInDays set to 0. ETag in If-Match is
            required for this operation. Deleting a locked immutability policy is
            not allowed, only way is to delete the container after deleting all
            blobs inside the container.

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param if_match: The entity state (ETag) version of the immutability
             policy to update. A value of "*" can be used to apply the operation
             only if the immutability policy already exists. If omitted, this
             operation will always be applied.
            :type if_match: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: ImmutabilityPolicy or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.ImmutabilityPolicy or
             ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.delete_immutability_policy.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'immutabilityPolicyName': self._serialize.url("self.immutability_policy_name", self.immutability_policy_name, 'str'),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            header_parameters['If-Match'] = self._serialize.header("if_match", if_match, 'str')
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.delete(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            header_dict = {}
            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('ImmutabilityPolicy', response)
                header_dict = {
                    'ETag': 'str',
                }

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                client_raw_response.add_headers(header_dict)
                return client_raw_response

            return deserialized
        delete_immutability_policy.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}/immutabilityPolicies/{immutabilityPolicyName}'}

        def lock_immutability_policy(
                self, resource_group_name, account_name, container_name, if_match, custom_headers=None, raw=False, **operation_config):
            """Sets the ImmutabilityPolicy to Locked state. The only action allowed on
            a Locked policy is ExtendImmutabilityPolicy action. ETag in If-Match is
            required for this operation.

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param if_match: The entity state (ETag) version of the immutability
             policy to update. A value of "*" can be used to apply the operation
             only if the immutability policy already exists. If omitted, this
             operation will always be applied.
            :type if_match: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: ImmutabilityPolicy or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.ImmutabilityPolicy or
             ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.lock_immutability_policy.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            header_parameters['If-Match'] = self._serialize.header("if_match", if_match, 'str')
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            header_dict = {}
            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('ImmutabilityPolicy', response)
                header_dict = {
                    'ETag': 'str',
                }

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                client_raw_response.add_headers(header_dict)
                return client_raw_response

            return deserialized
        lock_immutability_policy.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}/immutabilityPolicies/default/lock'}

        def extend_immutability_policy(
                self, resource_group_name, account_name, container_name, if_match, immutability_period_since_creation_in_days, custom_headers=None, raw=False, **operation_config):
            """Extends the immutabilityPeriodSinceCreationInDays of a locked
            immutabilityPolicy. The only action allowed on a Locked policy will be
            this action. ETag in If-Match is required for this operation.

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param if_match: The entity state (ETag) version of the immutability
             policy to update. A value of "*" can be used to apply the operation
             only if the immutability policy already exists. If omitted, this
             operation will always be applied.
            :type if_match: str
            :param immutability_period_since_creation_in_days: The immutability
             period for the blobs in the container since the policy creation, in
             days.
            :type immutability_period_since_creation_in_days: int
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: ImmutabilityPolicy or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.ImmutabilityPolicy or
             ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            parameters = None
            if immutability_period_since_creation_in_days is not None:
                parameters = models.ImmutabilityPolicy(immutability_period_since_creation_in_days=immutability_period_since_creation_in_days)

            # Construct URL
            url = self.extend_immutability_policy.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            header_parameters['If-Match'] = self._serialize.header("if_match", if_match, 'str')
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            if parameters is not None:
                body_content = self._serialize.body(parameters, 'ImmutabilityPolicy')
            else:
                body_content = None

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            header_dict = {}
            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('ImmutabilityPolicy', response)
                header_dict = {
                    'ETag': 'str',
                }

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                client_raw_response.add_headers(header_dict)
                return client_raw_response

            return deserialized
        extend_immutability_policy.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}/immutabilityPolicies/default/extend'}

        def lease(
                self, resource_group_name, account_name, container_name, parameters=None, custom_headers=None, raw=False, **operation_config):
            """The Lease Container operation establishes and manages a lock on a
            container for delete operations. The lock duration can be 15 to 60
            seconds, or can be infinite.

            :param resource_group_name: The name of the resource group within the
             user's subscription. The name is case insensitive.
            :type resource_group_name: str
            :param account_name: The name of the storage account within the
             specified resource group. Storage account names must be between 3 and
             24 characters in length and use numbers and lower-case letters only.
            :type account_name: str
            :param container_name: The name of the blob container within the
             specified storage account. Blob container names must be between 3 and
             63 characters in length and use numbers, lower-case letters and dash
             (-) only. Every dash (-) character must be immediately preceded and
             followed by a letter or number.
            :type container_name: str
            :param parameters: Lease Container request body.
            :type parameters:
             ~azure.mgmt.storage.v2018_07_01.models.LeaseContainerRequest
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: LeaseContainerResponse or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storage.v2018_07_01.models.LeaseContainerResponse
             or ~msrest.pipeline.ClientRawResponse
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            # Construct URL
            url = self.lease.metadata['url']
            path_format_arguments = {
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'accountName': self._serialize.url("account_name", account_name, 'str', max_length=24, min_length=3),
                'containerName': self._serialize.url("container_name", container_name, 'str', max_length=63, min_length=3),
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1)
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            if parameters is not None:
                body_content = self._serialize.body(parameters, 'LeaseContainerRequest')
            else:
                body_content = None

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                exp = CloudError(response)
                exp.request_id = response.headers.get('x-ms-request-id')
                raise exp

            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('LeaseContainerResponse', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        lease.metadata = {'url': '/subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/blobServices/default/containers/{containerName}/lease'}